<?php
/*
 * Filename.....: inc_ebay_de.php
 * Aufgabe......: Get infos from an ebay auction
 * Parameter....: auction number
 * Erstellt am..: Montag, 28. Juli 2003, 20:19:23
 *       _  __      _ _
 *  ||| | |/ /     (_) |        Wirtschaftsinformatiker IHK
 * \. ./| ' / _ __  _| |_ ___   www.ingoknito.de
 * - ^ -|  < | '_ \| | __/ _ \  
 * / - \| . \| | | | | || (_) | Peter Klauer
 *  ||| |_|\_\_| |_|_|\__\___/  06131-651236
 * mailto.......: knito@knito.de
 *
 * nderungen:
 * 2004-01-01: s. 2003-11-28: Schon wieder nix mehr.
 *             Artikelbezeichnung ist jetzt nicht mehr an feste Zeile gebunden.
 *             Startzeit, Endzeitermittlung gendert, 
 *             "Verkauft fr" statt "verkauft fr" in Preisermittlung
 * 2003-11-28: s. 2003-11-09: Schon wieder nix mehr.
 *             Artikelbezeichnung von Zeile 7 nach Zeile 8 gendert.
 * 2003-11-09: Nix geht mehr: Ebay hat die Seiten gendert. Nachpflege erforderlich.
 *             Artikelbezeichnung von Zeile 8 nach Zeile 7 gendert
 *             Auktionsstart, Ende vor MEZ, nicht mehr vor MESZ
 * 2003-09-25: Nur-Sofortkauf setzt bei erfolgreichem Verkauf den
 *             Sofortkauf auf Null, das Gebot auf den Sofortkaufpreis
 *             und die Anzahl der Gebote auf 1.
 *             (Anregung von Herrn Frank Ronneburg)
 * 2003-09-17: Beginning and ending tag of the eBay "Description" 
 *             section were changed by ebay. Corrected.
 * 2003-08-21: Do not show messed up data when ebay is down
 * 2003-07-29: new function init(), changed showdata()
 */
 
class ebay_de
{
  var $artikelnr = '';
  var $ebayurl = 'http://cgi.ebay.de/ws/eBayISAPI.dll?ViewItem&item=';
  var $html = '';
  
  var $artikel = 0;
  var $beschreibung = 0;
  var $startpreis = 0;
  var $sofortkauf = 0;
  var $gebot = 0;
  var $region = 0;
  
  var $auktionsende = 0;
  var $auktionsbeginn = 0;
  
  var $aktiv = '';
  var $anzahlgebote = '';
  
  ###################
  
  var $_sofortkauf = false;
  
  function init()
  {
    $this->artikel = 0;
    $this->beschreibung = 0;
    $this->startpreis = 0;
    $this->sofortkauf = 0;
    $this->gebot = 0;
    $this->region = 0;
    
    $this->auktionsende = 0;
    $this->auktionsbeginn = 0;
    
    $this->aktiv = '';
    $this->anzahlgebote = '';
    $this->_sofortkauf = false;
  }  
  
  function ebay_de( $artikelnr = 0 )
  {
    $this->artikelnr = $artikelnr;
    if( $artikelnr > 0 ) $this->getdata(0);
  }

  function getebayurl( $target = '' )
  {
    $t = $target == '' ? '' : ' target="'.$target.'"';
    return( '<a href="http://www.ebay.de/"'.$t.'><b>'.
    '<span style="color:red">e</span>'.
    '<span style="color:navy">B</span>'.
    '<span style="color:#ffc000">a</span>'.
    '<span style="color:green">y</span></b></a>');
  }
    
  function geturl( $text='', $target='', $class='' )
  {
    $tx = $text   == '' ? $this->artikel : $text;
    $ta = $target == '' ? '' : ' target="'.$target.'"';
    $cl = $class  == '' ? '' : ' class="'.$class.'"';
    return ("<a$cl href=\"".
    str_replace( '&', '&amp;', $this->ebayurl) .$this->artikelnr."\"$ta>$tx</a>");
  }
  
  function getprice( $string='EUR', $ende = '<', $maxlines = 5 )
  {
    $s = '';
    $lines = 0;  
    while( list( $key, $line ) = each( $this->html ) )
    {
      $lines ++;
      if( $lines > $maxlines ) break;
      
      $p2 = strpos( "@$line", $string );
      if( $p2 > 0 )
      {
        $i = $p2 + strlen($string);
        while( substr( $this->html[$key], $i, 1 ) != $ende )
        {
          $s .= substr( $this->html[$key], $i++, 1 );
        }
        break;
      } // if $p2 > 0
      
    } // while
    return $s;
  }  
 
  function getdata( $print = 1)
  {
    $this->html = file( $this->ebayurl.$this->artikelnr );
    $i = 0;

    $p1 = 0; $p2 = 0;
    $startpreis = 0;
    
    #
    # Werte auslesen
    #
    $n = 0;
    while( list( $key, $line ) = each( $this->html ) )
    {
      $l = "@$line";
      
      if( !is_string( $this->auktionsbeginn ) )
      {
        if( strpos( $l, '<!--Started: ' ) > 0 )
        {
        
          # <!--Started: 14.09.0318:45:40 MESZ--> (MESZ oder MEZ? Beides mglich!)
          $p1 = strpos( $l, 'MESZ' ) - 18;
          if( $p1 < 0 ) $p1 = strpos( $l, 'MEZ' ) - 18;
          $this->auktionsbeginn = substr( $l, $p1, 18 );
        }        
      }
      
      if( !is_string( $this->artikel ) )
      {
        if( strpos( $l, '<title>' ) > 0 )
        {
          #
          # artikelbezeichnung nach $this->artikel holen
          #    
          $p1 = strpos( $l, ' - ' ) + 3;
          $p2 = strpos( $l, '</title', $p1 );
          $this->artikel = trim(substr( $l, $p1, $p2 - $p1 ));
    
          #
          # in der selben Zeile steht auch Endet 29.07.03 20:31:36 MESZ 
          #
          $p1 = strpos( $l, 'MESZ' ) - 18;
          if( $p1 < 0 ) $p1 = strpos( $l, 'MEZ' ) - 18;          
          $this->auktionsende = substr( $l, $p1, 18 );
        }
      } // !is_string( $this->artikel )
      
      
      if( !is_string( $this->startpreis ) )
      {
        if(strpos( $l, 'Startpreis:' ) > 0)
        {
          prev( $this->html );      
          $this->startpreis = $this->getprice();
        }
      }
      
      if( !is_string( $this->sofortkauf ) )
      {
        if( strpos( $l, '"Sofort-Kaufen"') > 0 ) 
        {
          prev( $this->html );        
          $this->sofortkauf = $this->getprice();
        }
      }
      
      if( !is_string( $this->gebot ) )
      {
        if( strpos( $l, 'Aktuelles Gebot:') > 0 )
        {
          prev( $this->html );        
          $this->gebot = $this->getprice();
        }
        if( strpos( $l, 'Erfolgreiches Gebot:')>0)
        {
          prev( $this->html );        
          $this->gebot = $this->getprice();
          $this->aktiv = false;
        }
        
        if(( strpos( $l,'Angebot ist beendet') > 0) and (strpos( $l,'der Kufer)')>0))
        {
          $this->_sofortkauf = true;
          $this->anzahlgebote = 1; 
        }
       
        if(strpos( $l,'Verkauft fr:' ) > 0 )
        {
          $this->gebot = $this->getprice();
          $this->sofortkauf = $this->gebot;
          $this->aktiv = false;
        }
        
      }
      
      if( !is_bool( $this->aktiv ) )
      {
        if( strpos( $l, 'var pageName' ) > 0 )
        {
          $arr = split( '_', $l );
          $this->aktiv = $arr[1] == 'Active' ? true : false;
        }
      }
      
      if( !is_string( $this->region ) )
      {
        if( strpos( $l, 'var region' ) > 0 )
        {
          $arr = split( '"', $l );
          $this->region = $arr[1];
        }
      }
      
      if( is_string( $this->anzahlgebote ) )
      {
        $gebotpos = strpos( $l, ' Gebote<' );
        if( !$gebotpos ) $gebotpos = strpos( $l, ' Gebot<' );
        if( $gebotpos > 0 )
        {
          $s = '';
          while( true )
          {
            $sub = substr( $l, $gebotpos, 1 );
            if( $sub == '>' )
            {          
              break;

            }
            else
            {
              $s = $sub . $s;
            }
            $gebotpos--;
          }
          $this->anzahlgebote = intval( $s );
          
          # Startpreis steht dahinter          
          if( $this->anzahlgebote > 0 ) $this->startpreis = $this->getprice('EUR',' ');           
        }
      }
      
      
      # Description?      
      if( $p1 == 0 )
      {  
        $p1 = strpos( $l, '<!--Begin Description-->'  );
        if( !($p1 > 0) ) $p1 = strpos( $l, '<!-- Begin Description -->' );
        if( $p1 > 0 ) $a = $key;
      }
      if( $p2 == 0 )
      {
        $p2 = strpos( $l,  '<!--End Description-->' );
        if( !($p2 > 0 ) ) $p2 = strpos( $l, '<!-- End Description -->' );
        if( $p2 > 0 ) $b = $key;
      }
      
    }
    
    /*
     * Kann auch wg. hochgeladener HTML-Seite so sein!
     *    
    if( !isset( $a ) and !isset($b) )
    {
       $this->beschreibung = 'Die Auktion '.$this->artikelnr.' kann nicht gefunden werden.';
       $this->artikel = 'Auktion nicht auffindbar';
       $this->auktionsbeginn = 0;
       $this->auktionsende = 0;
       $this->ebayurl = 'http://www2.ebay.com/aw/marketing-de.shtml?'; 
    }
     */
    
    #
    # Description (Beschreibung) zusammensetzen
    #
    $s = substr( $this->html[$a], $p1-1 ); // erste zeile
    for( $i = $a+1; $i < $b; $i++ ) $s .= $this->html[$i]; // der ganze rest
    $s .= substr( $this->html[$b], 0, $p2-1 ); // letzte zeile
    $this->beschreibung = $s;  


    if( ($this->_sofortkauf == true) and ($this->gebot == 0) )
    {
      $this->gebot = $this->sofortkauf;
      $this->sofortkauf = 0;
    }    
    
    if( $print == 1 )
    {
      reset( $this->html );
      $i = 0;          
      while( list( $key, $line ) = each( $this->html ) ) 
      {
        echo $i++.' '.htmlspecialchars($line).'<br>';
      }
      
    } // if( $print == 1 )
    
  } // function getdata()
  
  function showdata( $tdclass = '', $thclass='', $target='', $width='')
  {
    $tdc = $tdclass == '' ? '' : " class='$tdclass'";
    $thc = $thclass == '' ? '' : " class='$thclass'";
    $wid = $width   == '' ? '' : " width='$width'";
    
    echo '<table'.$wid.' cellpadding=4 cellspacing=1 border=1 rules="groups" summary="eBay-Data Artikel '.$this->artikelnr.'">'.
    '<colgroup><col></colgroup><colgroup><col span=2></colgroup>'.
    '<colgroup><col></colgroup><colgroup><col span=2></colgroup>'.
    '<tbody>'.
    '<tr><th'.$thc.' colspan=6 align=center>'.
    $this->getebayurl( $target ).' Auktion: '.
    $this->geturl( '',$target ).'</th></tr>'.
    '<tbody>'.    
    '<tr><td'.$tdc.'>Startpreis:</td><td'.$tdc.' align=right>&euro;</td><td align=right'.$tdc.'>'.$this->startpreis.'</td>'.
    '<td'.$tdc.'>aktuelles Gebot:</td><td'.$tdc.' align=right>&euro;</td><td align=right'.$tdc.'>'.$this->gebot.'</td></tr>'.
    '<tr><td'.$tdc.'>Sofortkauf:</td><td'.$tdc.' align=right>&euro;</td><td align=right'.$tdc.'>';
    
    $s = (( strlen( trim( $this->sofortkauf ) ) == 0 ) or ( intval( $this->sofortkauf ) == 0  )) ? 'nicht mglich' : $this->sofortkauf;
    
    echo $s.'</td>'.
    '<td'.$tdc.'>Anzahl Gebote:</td><td align=right colspan=2'.$tdc.'>'.$this->anzahlgebote.'</td></tr>'.
    '<tbody>'.
    '<tr><td'.$tdc.'>Region:</td><td align=right'.$tdc.'>'.$this->region.'</td>'.
    '<td'.$tdc.' align=right>Auktionsbeginn:</td><td'.$tdc.' colspan=3>'.$this->auktionsbeginn.'</td></tr>'.    
    '<tr><td'.$tdc.'>Status:</td><td align=right'.$tdc.'>'.($this->aktiv ? 'Luft noch' : 'Geschlossen').'</td>'.    
    '<td'.$tdc.' align=right>Auktionsende:</td><td'.$tdc.' colspan=3>'.$this->auktionsende.'</td></tr>'.
    '</table>';
  } // function showdata()
  
} // class ebay_de    
?>